/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables;


import com.flamesgroup.commons.IMEI;
import com.flamesgroup.storage.convert.DateConverter;
import com.flamesgroup.storage.convert.IccidConverter;
import com.flamesgroup.storage.convert.ImeiConverter;
import com.flamesgroup.storage.convert.PhoneNumberConverter;
import com.flamesgroup.storage.jooq.Keys;
import com.flamesgroup.storage.jooq.Public;
import com.flamesgroup.storage.jooq.tables.records.SimRecord;
import com.flamesgroup.unit.ICCID;
import com.flamesgroup.unit.PhoneNumber;

import java.util.Arrays;
import java.util.Date;
import java.util.List;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class Sim extends TableImpl<SimRecord> {

	private static final long serialVersionUID = 1222553780;

	/**
	 * The reference instance of <code>public.sim</code>
	 */
	public static final Sim SIM = new Sim();

	/**
	 * The class holding records for this type
	 */
	@Override
	public Class<SimRecord> getRecordType() {
		return SimRecord.class;
	}

	/**
	 * The column <code>public.sim.id</code>.
	 */
	public final TableField<SimRecord, Long> ID = createField("id", org.jooq.impl.SQLDataType.BIGINT.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.sim.iccid</code>.
	 */
	public final TableField<SimRecord, ICCID> ICCID = createField("iccid", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "", new IccidConverter());

	/**
	 * The column <code>public.sim.enabled</code>.
	 */
	public final TableField<SimRecord, Boolean> ENABLED = createField("enabled", org.jooq.impl.SQLDataType.BOOLEAN.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.sim.locked</code>.
	 */
	public final TableField<SimRecord, Boolean> LOCKED = createField("locked", org.jooq.impl.SQLDataType.BOOLEAN.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.sim.lock_reason</code>.
	 */
	public final TableField<SimRecord, String> LOCK_REASON = createField("lock_reason", org.jooq.impl.SQLDataType.CLOB, this, "");

	/**
	 * The column <code>public.sim.lock_time</code>.
	 */
	public final TableField<SimRecord, Date> LOCK_TIME = createField("lock_time", org.jooq.impl.SQLDataType.TIMESTAMP, this, "", new DateConverter());

	/**
	 * The column <code>public.sim.all_call_count</code>.
	 */
	public final TableField<SimRecord, Integer> ALL_CALL_COUNT = createField("all_call_count", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.sim.successful_call_count</code>.
	 */
	public final TableField<SimRecord, Integer> SUCCESSFUL_CALL_COUNT = createField("successful_call_count", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.sim.successful_call_duration</code>.
	 */
	public final TableField<SimRecord, Long> SUCCESSFUL_CALL_DURATION = createField("successful_call_duration", org.jooq.impl.SQLDataType.BIGINT.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.sim.sim_group_id</code>.
	 */
	public final TableField<SimRecord, Long> SIM_GROUP_ID = createField("sim_group_id", org.jooq.impl.SQLDataType.BIGINT, this, "");

	/**
	 * The column <code>public.sim.incoming_call_count</code>.
	 */
	public final TableField<SimRecord, Integer> INCOMING_CALL_COUNT = createField("incoming_call_count", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.sim.incoming_successful_call_count</code>.
	 */
	public final TableField<SimRecord, Integer> INCOMING_SUCCESSFUL_CALL_COUNT = createField("incoming_successful_call_count", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.sim.incoming_successful_call_duration</code>.
	 */
	public final TableField<SimRecord, Long> INCOMING_SUCCESSFUL_CALL_DURATION = createField("incoming_successful_call_duration", org.jooq.impl.SQLDataType.BIGINT.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.sim.reset_ss_scripts_flag</code>.
	 */
	public final TableField<SimRecord, Boolean> RESET_SS_SCRIPTS_FLAG = createField("reset_ss_scripts_flag", org.jooq.impl.SQLDataType.BOOLEAN.defaulted(true), this, "");

	/**
	 * The column <code>public.sim.reset_vs_scripts_flag</code>.
	 */
	public final TableField<SimRecord, Boolean> RESET_VS_SCRIPTS_FLAG = createField("reset_vs_scripts_flag", org.jooq.impl.SQLDataType.BOOLEAN.defaulted(true), this, "");

	/**
	 * The column <code>public.sim.imei</code>.
	 */
	public final TableField<SimRecord, IMEI> IMEI = createField("imei", org.jooq.impl.SQLDataType.CLOB, this, "", new ImeiConverter());

	/**
	 * The column <code>public.sim.phone_number</code>.
	 */
	public final TableField<SimRecord, PhoneNumber> PHONE_NUMBER = createField("phone_number", org.jooq.impl.SQLDataType.CLOB, this, "", new PhoneNumberConverter());

	/**
	 * The column <code>public.sim.success_sms_count</code>.
	 */
	public final TableField<SimRecord, Integer> SUCCESS_SMS_COUNT = createField("success_sms_count", org.jooq.impl.SQLDataType.INTEGER.defaulted(true), this, "");

	/**
	 * The column <code>public.sim.incoming_sms_count</code>.
	 */
	public final TableField<SimRecord, Integer> INCOMING_SMS_COUNT = createField("incoming_sms_count", org.jooq.impl.SQLDataType.INTEGER.defaulted(true), this, "");

	/**
	 * The column <code>public.sim.total_sms_count</code>.
	 */
	public final TableField<SimRecord, Integer> TOTAL_SMS_COUNT = createField("total_sms_count", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.sim.total_sms_statuses</code>.
	 */
	public final TableField<SimRecord, Integer> TOTAL_SMS_STATUSES = createField("total_sms_statuses", org.jooq.impl.SQLDataType.INTEGER.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.sim.note</code>.
	 */
	public final TableField<SimRecord, String> NOTE = createField("note", org.jooq.impl.SQLDataType.CLOB, this, "");

	/**
	 * The column <code>public.sim.allowed_internet</code>.
	 */
	public final TableField<SimRecord, Boolean> ALLOWED_INTERNET = createField("allowed_internet", org.jooq.impl.SQLDataType.BOOLEAN.defaulted(true), this, "");

	/**
	 * The column <code>public.sim.tariff_plan_end_date</code>.
	 */
	public final TableField<SimRecord, Long> TARIFF_PLAN_END_DATE = createField("tariff_plan_end_date", org.jooq.impl.SQLDataType.BIGINT.nullable(false).defaulted(true), this, "");

	/**
	 * Create a <code>public.sim</code> table reference
	 */
	public Sim() {
		this("sim", null);
	}

	/**
	 * Create an aliased <code>public.sim</code> table reference
	 */
	public Sim(String alias) {
		this(alias, SIM);
	}

	private Sim(String alias, Table<SimRecord> aliased) {
		this(alias, aliased, null);
	}

	private Sim(String alias, Table<SimRecord> aliased, Field<?>[] parameters) {
		super(alias, Public.PUBLIC, aliased, parameters, "");
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Identity<SimRecord, Long> getIdentity() {
		return Keys.IDENTITY_SIM;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public UniqueKey<SimRecord> getPrimaryKey() {
		return Keys.SIM_PKEY_IND;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<UniqueKey<SimRecord>> getKeys() {
		return Arrays.<UniqueKey<SimRecord>>asList(Keys.SIM_PKEY_IND, Keys.SIM_KEY_KEY_IND);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<ForeignKey<SimRecord, ?>> getReferences() {
		return Arrays.<ForeignKey<SimRecord, ?>>asList(Keys.SIM__SIM_SIM_GROUP_ID_FKEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Sim as(String alias) {
		return new Sim(alias, this);
	}

	/**
	 * Rename this table
	 */
	public Sim rename(String name) {
		return new Sim(name, null);
	}
}
